package issueData;

import org.apache.commons.codec.digest.DigestUtils;

import java.util.Objects;

public class Comment {

    private String hash;
    private String author;
    private String message;
    private long creationTime;

    public Comment(String author, String message) {
        this.author = author;
        this.message = message;
        this.creationTime = System.currentTimeMillis();
        this.hash = DigestUtils.sha256Hex(author + message + creationTime);
    }

    public Comment() {
    }

    public String getHash() {
        return hash;
    }

    public void setHash(String hash) {
        this.hash = hash;
    }

    public String getAuthor() {
        return author;
    }

    public void setAuthor(String author) {
        this.author = author;
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public long getCreationTime() {
        return creationTime;
    }

    public void setCreationTime(long creationTime) {
        this.creationTime = creationTime;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Comment comment = (Comment) o;
        return creationTime == comment.creationTime &&
                Objects.equals(hash, comment.hash) &&
                Objects.equals(author, comment.author) &&
                Objects.equals(message, comment.message);
    }

    @Override
    public int hashCode() {
        return Objects.hash(hash, author, message, creationTime);
    }
}
